0 var x 0 var y
0 var angle
0 var dx 0 var dy

hex create cosTable
-2 , F9F2 , E9DD , 
CEBD , AA95 , 7F67 , 
4E34 , 1A00 , decimal

: cos ( ang -- cos[ang])
  abs 60 mod dup 29 > if
    60 swap -
  then
  dup 14 > if
    -1 30 rot -
  else
    1 swap
  then
  cosTable + c@ 1+ *
;

: fixPoint!
  >r 80 + 8 << r> !
;

: jump ( dist--)
  dup dx @ * x +!
  dy @ * y +!
;

: setPos ( x y --)
  y fixPoint!
  x fixPoint!
;

: setH ( heading --)
  dup angle !
  dup cos dy !
  45 + cos dx !
;

blk# @ 1- load
: fd ( dist--)
  >r dx @ x @ y @ dy @
  r 0 do
    >r r + >r over +
    dup 8 >> r 8 >> plot
    r> r>
  loop
  drop y ! x ! drop
  r> drop
;

: turtleEnd
  0 0 at
  ." Press a key to end"
  key 0 vmode
;

: home
  1 vmode 1 pen cls 
  0 0 setPos 0 setH
;

: rt ( turn--)
  angle @ + setH
;

decimal

: poly
  0 do
    2dup fd rt
  loop
  drop drop
;

: circle
  1 4 60 poly
;

: spiral
  15 0 do
    circle 4 rt
  loop
;

: burst
  60 0 do
    0 0 setPos i setH
    110 fd
  loop
;

: star
  24 80 5 poly
;

: stars
  3 0 do
    star 20 rt
  loop
;

: squiral
  -50 -50 setPos
  20 0 do
    100 fd 21 rt
  loop
;

: rose
  0 50 0 do
    2+ dup fd 14 rt
  loop
;

: halfPetal
  1 5 15 poly
  -1 2 15 poly
;

: petal
  halfPetal 30 rt
  halfPetal 30 rt
;

: flower
  15 0 do
    petal 4 rt
  loop
;

blk# @ 2 - load
blk# @ 1- load

: nextDemo
  -500 pause
  home
;

: sin
  160 0 do
    i i cos
    4 / 80 + plot
  loop
;

: turtles
  home
  begin
    sin nextDemo
    burst nextDemo
    squiral nextDemo
    spiral nextDemo
    stars nextDemo
    rose nextDemo
    flower nextDemo
  inkey 13 = until
  turtleEnd
;
